#include <Wire.h>
#include <Servo.h>
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27, 16, 2);

float temp;
Servo servo;
int ledverte = 4;
int ledrouge = 2;
float temp_lim;
bool moteur = false;
int pas = -180;
int pos = 0;


void setup()
{
  servo.attach(9);
  Serial.begin(9600);
  pinMode (A0, INPUT);
  pinMode (A2, INPUT);
  pinMode (A4, INPUT);
  pinMode (A5, INPUT);
  pinMode (ledrouge, OUTPUT);
  pinMode (ledverte, OUTPUT);
  pinMode (0, OUTPUT);
  lcd.init();
  servo.write(0);
}

void loop()
  {
  lecture_temp();              //on récupère la température extérieure
  temp_lim = temp_max();      //on récupère la température limite
  affichage_led (temp);        // on commande les leds
  affichage_lcd (temp,moteur); //on  affiche sur l'écran lcd
  action_ventil();   //on actionne le ventilateur
  //action_ventil2();
  } 


void lecture_temp()
{
  int test = analogRead(A0);        //lecture de la première mesure (non utilisée ensuite)
  int valeur_capteur = analogRead(A0);
  temp = valeur_capteur * (5.0 / 1023.0 * 100.0);  //conversion du numérique en degré celcius
  delay (250);
  //Serial.println (valeur_capteur);  //pour tests
  Serial.println (temp);   
}


void affichage_led(float temp)
  {
  if (temp<temp_lim){            //si température basse, led rouge allumée
      digitalWrite (ledverte, LOW);
      digitalWrite (ledrouge, HIGH);
      }
      else  {                    //si température limite dépassée, led verte allumée
          digitalWrite (ledverte, HIGH);
          digitalWrite (ledrouge, LOW);
          }
  }
  

void affichage_lcd (float temp, bool moteur)
  {
   if (moteur)
    {
      lcd.backlight();
      lcd.clear();
      lcd.setCursor (1,0);
      lcd.print("Ventilateur ON");
      lcd.setCursor (1,1);
      lcd.print(temp_lim);
      lcd.print(" - ");
      lcd.print(temp);
      lcd.print((char)223);
      lcd.print("C"); 
      delay(250);
    }
    else {
      lcd.backlight();
      lcd.clear();
      lcd.setCursor (1,0);
      lcd.print("Ventilateur OFF");
      lcd.setCursor (0,1);
      lcd.print(temp_lim);
      lcd.print(" - ");
      lcd.print(temp);
      lcd.print((char)223);
      lcd.print("C");
      delay(250);
    }
    
  }


void action_ventil()
  {
    if (temp>temp_lim)
    {
      if (pos>=180)
        {
        pas = - pas;
        }
      if (pos <=0)
        {
        pas = - pas;
        }
    servo.write(pos);
    pos = pos + pas;
    moteur = true;
    }
      else 
      {
      servo.write(0);
      moteur = false;
      }   
   
  }
  
float temp_max()
{
 int valeur_pot = analogRead(A2);       //lecture sur le potentiomètre entre 0 et 5V, numérisée par le microcontroleur
 temp_lim = (valeur_pot * 5.0 / 1023.0 *4 +10 );
 //Serial.println (temp_lim);
 //choix de valeurs entre 10 et 30°C 
 return temp_lim;
 
}
  
void action_ventil2()  
{
   if (temp>temp_lim)
    {
      digitalWrite (0, HIGH);
      moteur = true;
    }
      else 
      {
      digitalWrite (0, LOW);
      moteur = false;
      }   
}
